package checkHadoop;

import java.io.IOException;
import java.net.URI;

import org.apache.hadoop.conf.Configuration;
import org.apache.hadoop.fs.Path;
import org.apache.hadoop.io.IntWritable;
import org.apache.hadoop.io.LongWritable;
import org.apache.hadoop.io.Text;
import org.apache.hadoop.mapred.InputFormat;
import org.apache.hadoop.mapred.jobcontrol.JobControl;
import org.apache.hadoop.mapreduce.Job;
import org.apache.hadoop.mapreduce.Mapper;
import org.apache.hadoop.mapreduce.Reducer;
import org.apache.hadoop.mapreduce.lib.input.FileInputFormat;
import org.apache.hadoop.mapreduce.lib.jobcontrol.ControlledJob;
import org.apache.hadoop.mapreduce.lib.output.FileOutputFormat;

public class Main {
	
	public static void main(final String[] args) throws IOException, ClassNotFoundException, InterruptedException {
		
	
	    //Action Rules Configuration
		Configuration actionRulesConf = new Configuration();
		Job actionRulesJob;
		actionRulesJob = Job.getInstance(actionRulesConf, "Action Rules");
				
		actionRulesJob.setJarByClass(ActionRules.class);
		actionRulesJob.setMapperClass(ActionRules.JobMapper.class);
		//actionRulesJob.setCombinerClass(ActionRules.JobReducer.class);
		//actionRulesJob.setReducerClass(ActionRules.JobReducer.class);
                
                actionRulesJob.setNumReduceTasks(0);
				   				    
		actionRulesJob.setOutputKeyClass(Text.class);
		actionRulesJob.setOutputValueClass(Text.class);
				    
		/*
	     * Adding commmon data to all maps to the DistributedCache
	     * These contents are accessed in setup() in the Mapper class
	     */
		actionRulesJob.addCacheFile(new Path(args[0]).toUri());
		actionRulesJob.addCacheFile(new Path(args[2]).toUri());
				    
		FileInputFormat.addInputPath(actionRulesJob, new Path(args[1]));
				    
		FileOutputFormat.setOutputPath(actionRulesJob, new Path(args[3]));
		System.exit(actionRulesJob.waitForCompletion(true) ? 0 : 1);
				    	    
	   
	}
	
}