package edu.uncc.kdd;

import java.awt.Color;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.swing.BoxLayout;
import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

/**
 * 
 * @author apoorva
 *
 */
public class Application extends JFrame {

	private static final long serialVersionUID = 1L;

	public Application() {
		initUI();
	}
	static JTextField supportField;
	static JTextField confidenceField;
	static JLabel decisionLabel = new JLabel();
	static JTextField decisionFromField = new JTextField(10);
	static JTextField decisionToField = new JTextField(10);
	public static void main(String[] args) {

		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException | InstantiationException
				| IllegalAccessException | UnsupportedLookAndFeelException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		EventQueue.invokeLater(new Runnable() {

			@Override
			public void run() {
				Application actionRules = new Application();
				actionRules.setVisible(true);
			}
		});
	}


	static DefaultListModel decisionModel = new DefaultListModel();
	static DefaultListModel stableModel = new DefaultListModel();

	/**
	 * Initialize UI
	 */
	private void initUI() {

		this.setJMenuBar(GUI.addMenuBar(this));

		final JList stableList = new JList(stableModel);
		final JList decisionList = new JList(decisionModel);

		stableModel.addElement("......Select......");
		decisionModel.addElement("......Select......");

		stableList.setVisibleRowCount(10);
		stableList.setFixedCellHeight(12);
		//stableList.setBackground(Color.GRAY.brighter());

		decisionList.setVisibleRowCount(6);
		decisionList.setFixedCellHeight(12);


		decisionList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		stableList.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);

		stableList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				if (evt.getValueIsAdjusting())
					return;
				List<String> selectedText = (ArrayList<String>)stableList.getSelectedValuesList();
				System.out.println(selectedText.size());
				Rules.setStableAttributes(Rules.attributeNames, selectedText);
			}
		});

		decisionList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent evt) {
				if (evt.getValueIsAdjusting())
					return;
				Rules.setDecisionAttribute(Rules.attributeNames);
			}
		});

		final JPanel mainPanel = new JPanel();
		final JPanel topPanel = new JPanel();
		final JPanel midPanel = new JPanel();
		final JPanel endPanel = new JPanel();
		final JPanel runPanel = new JPanel();
		JLabel supportlbl = new JLabel("Enter the support");
		supportField= new JTextField(10);
		JLabel conflbl = new JLabel("Enter the confidence");
		confidenceField = new JTextField(10);
		JButton btnRun = new JButton("Run");
		JLabel stablelbl = new JLabel("Select stable attributes");
		JLabel decisionlbl = new JLabel("Select decision attribute");

		JLabel decisionFromlbl = new JLabel("Change decision attribute from ");
		JLabel decisionTolbl = new JLabel("Change decision attribute to ");



		JLabel lbl = new JLabel("Possible decision attributes are:");
		decisionLabel.setText("----");


		topPanel.add(supportlbl);
		topPanel.add(supportField);
		topPanel.add(conflbl);
		topPanel.add(confidenceField);

		midPanel.add(stablelbl);
		midPanel.add(stableList);
		midPanel.add(decisionlbl);
		midPanel.add(decisionList);

		endPanel.add(lbl);
		endPanel.add(decisionLabel);
		endPanel.add(decisionFromlbl);
		endPanel.add(decisionFromField);
		endPanel.add(decisionTolbl);	
		endPanel.add(decisionToField);

		runPanel.add(btnRun);
		final JLabel lblRun = new JLabel("");

		// on button click
		btnRun.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {

				int supportElement=Integer.parseInt(supportField.getText().trim());
				float confidenceElement=Float.parseFloat(confidenceField.getText().trim());
				lblRun.setText("Running.....");
				Rules.setFlexibleAttributes();
				Rules.getDecisionFromValue();
				Rules.findRules(confidenceElement);
				try {
					Rules.certainRulesOutput.close();
					Rules.generateActionRules(supportElement,confidenceElement);
					Rules.actionRulesoutput.close();
					lblRun.setText("Check output files at C:\\Temp_Grp3");
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		});

		mainPanel.setLayout(new BoxLayout(mainPanel, BoxLayout.Y_AXIS));
		mainPanel.add(topPanel);
		mainPanel.add(midPanel);
		mainPanel.add(endPanel);
		mainPanel.add(runPanel);
		mainPanel.add(lblRun);
		this.add(mainPanel);
		setTitle("Part 2");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		setSize(600, 600);
		setResizable(false);
		setVisible(true);
	}
}