package edu.uncc.kdd;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

public class GUI {


	/**
	 * Create a menu bar
	 * @param mainFrame
	 * @return
	 */
	public static JMenuBar addMenuBar(final JFrame mainFrame){

		JMenuBar menuBar = new JMenuBar();
		JMenu fileMenu = new JMenu("File");
		menuBar.add(fileMenu);

		
		// Create and add simple menu item to one of the drop down menu
		JMenuItem openAction = new JMenuItem("Open names file");
		JMenuItem openDataAction = new JMenuItem("Open data file");
		JMenuItem exitAction = new JMenuItem("Exit");

		
		fileMenu.add(openAction);
		fileMenu.add(openDataAction);
		fileMenu.addSeparator();
		fileMenu.add(exitAction);

		
		openDataAction.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				String extType[] = { "data" };
				JFileChooser chooser = new JFileChooser();
				JFrame frame = new JFrame();
				FileFilter filter = new FileNameExtensionFilter("Data File",	extType);
				chooser.setFileFilter(filter);
				chooser.setDialogTitle("Opens Data File");

				int returnVal = chooser.showOpenDialog(frame);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					System.out.println("You chose to open this file: "+ chooser.getSelectedFile().getName());
					Rules.readData(chooser.getSelectedFile().getAbsolutePath());
					Rules.setDecisionAttribute(Rules.attributeNames);
				}						

			}
		});
	
		openAction.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				String extType[] = { "names" };
				JFileChooser chooser = new JFileChooser();
				JFrame frame = new JFrame();
				FileFilter filter = new FileNameExtensionFilter("Names File",	extType);
				chooser.setFileFilter(filter);
				chooser.setDialogTitle("Opens Names File");

				int returnVal = chooser.showOpenDialog(frame);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					System.out.println("You chose to open this file: "+ chooser.getSelectedFile().getName());					
					Rules.readAttributes(chooser.getSelectedFile().getAbsolutePath());
				}						

			}
		});


		exitAction.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent arg0) {
				System.exit(0);
			}
		});

		return menuBar;

	}

	}